import greenfoot.UserInfo;
import java.lang.String;
import java.util.List;

public class UserState
{
    UserInfo myInfo = null;
    char[] values = new char[50];
    
    public UserState()
    {
        if(UserInfo.isStorageAvailable()) {
            myInfo = UserInfo.getMyInfo();
            assignUniqueUserID();
        }
    }
    public int getID()
    {
        if(myInfo != null) {
            return myInfo.getScore();
        }
        return -1;
    }
    public static int getUserID(String username)
    {
        //May take a while if there are lots of users, as it loads ALL users
        //I intend to put a possible speed up by fetching each user by ID
        List<UserInfo> e = UserInfo.getTop(0);
        for(UserInfo u:e) {
            if(u.getUserName().equals(username)) {
                return u.getScore();
            }
        }
        return -1;
    }
    public static UserInfo getUser(int id)
    {
        UserInfo highest = (UserInfo)UserInfo.getTop(1).get(0);
        if(highest != null) {
            int highestID = highest.getScore();
            if(id > highestID)
                return null; //User does not exist! Highest assigned ID is less than id given
            if(id < 1)
                return null; //No ID assigned is ever < 1
            if(id == highestID)
                return highest;
            List<UserInfo> u = UserInfo.getTop(highestID - id + 1);
            return u.get(u.size() - 1);
        }
        return null;
    }
    public void assignUniqueUserID()
    {
        if(myInfo != null) {
            int currentID = myInfo.getScore();
            if(currentID == 0) {
                int newID;
                if(UserInfo.getTop(1).size() != 0) {
                    UserInfo highestID = (UserInfo)UserInfo.getTop(1).get(0);
                    newID = highestID.getScore()+1;
                }
                else {
                    newID = 1;
                }
                myInfo.setScore(newID);
                myInfo.store();
                for(int i = 0; i < 50; i++) {
                    setValue(i, 0);
                }
                store();
            }
            else {
                OtherUserState self = new OtherUserState(getID());
                for(int i = 0; i < 50; i++) {
                    setValue(i, self.getValue(i));
                }
            }
        }
        
    }
    /**
     * Sets the value at index to value
     * 0 <= index <= 49
     * 1 <= value <= 50000
     */
    public void setValue(int index, int value)
    {
        if((index >= 0) && (index <= 49)) {
            if((value >= 1) && (value <= 50000)) {
                if(value == 13)
                    values[index] = (char)50001;
                else if(value == 92)
                    values[index] = (char)50002;
                else
                    values[index] = (char)value;
            }
        }
    }
    public void store()
    {
        myInfo.setString(0, new String(values));
        myInfo.store();
    }
}
